/* Copyright (c) 2007 by IBM Corporation */

dojo.provide("zero.form.widget.field.TextField");

dojo.require("zero.form.widget.field.FieldInputBox");


dojo.declare(
    "zero.form.widget.field.TextField", 
    [zero.form.widget.field.FieldInputBox],
    {
		DEFAULT_CHARS_NUMBER: 99999,
		numOfChar: this.DEFAULT_CHARS_NUMBER,
		 
		constructor: function()
		{
			this.type = "text";
		},
		        
		isContentValid: function()
		{
				var currenLength = this.textbox.value.length;
				return (currenLength <= this.numOfChar);
		} ,
		
		startup: function()
		{
			zero.form.widget.field.TextField.superclass.startup.apply(this, arguments);
			
			if (!((undefined == this.defaultValue) || (null == this.defaultValue)))
				this.textbox.value = this.defaultValue;
			
			this.validate();
		},
		
		setAdditionalProperties: function(pJson)
		{
			zero.form.widget.field.TextField.superclass.setAdditionalProperties.apply(this, arguments);
			this.numOfChar = (pJson.numOfChars === undefined) ? this.DEFAULT_CHARS_NUMBER : pJson.numOfChars;
		},
		
		getAdditionalProperties: function(pJson)
		{
			zero.form.widget.field.TextField.superclass.getAdditionalProperties.apply(this, arguments);
			if (this.numOfChar !== undefined && this.numOfChar !== this.DEFAULT_CHARS_NUMBER) 
			{
				pJson.numOfChars = this.numOfChar;
			}
		},

		getNumOfChars: function() 
		{
			return this.numOfChar;
		},

		setNumOfChars: function(pNumOfChars) 
		{
			this.numOfChar = pNumOfChars;
		}
});
